<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

/* public abstract */ class inputStream extends serializeableObject {

   /* private String */ var $filename;
   /* private boolean */ var $exists = false;
   /* private Hashtable */ var $attributes = array();

   /* constructor */ function inputStream(/* String */ $filename) {
     settype($filename, "string");
     if (!is_readable($filename)) {
       $this->exists = false;
     } else {
       $this->attributes['MTIME'] = date("d.m.Y",filemtime($filename));
       $this->attributes['ATIME'] = date("d.m.Y H:i:s",fileatime($filename));
       $this->attributes['CTIME'] = date("d.m.Y",filectime($filename));
       $this->exists = true;
     }
     clearstatcache();
     $this->filename = $filename;
   }

   /* public abstract */ function read() {
     return true;
   }

   /* public String */ function get() {
     $text = "IO-Stream \"".$this->filename."\"\n";
     foreach ($this->attributes as $a => $b) {
       $text .= "\t- $a = $b\n";
     }
     return $text;
   }

   /* public String */ function toString() {     # overload this method for each sub class
     if (!$this->exists()) {
       return "Path to \"".$this->filename."\" does not exist\n";
     } elseif ($this->isEmpty()) {
       return "Path to \"".$this->filename."\" exists, but it is wether empty or not loaded\n";
     } else {
       return $this->get();
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   /* public String */ function getFilename() {
     return ( $this->filename );
   }

   /* public boolean */ function exists() {
     return ( $this->exists );
   }

   /* public boolean */ function isEmpty() {
     return ( false );
   }

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
