<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

class secureFileStream extends secureInputStream {

   /* public void */ function insert($text) {
     $this->content[count($this->content)] = $text;
   }

   /* public boolean */ function write() {
     settype($this->content, "array");
     settype($this->source, "array");

     if ($this->is_writeable() &&
        ( crc32(implode("", file($this->filename))) == crc32(implode("", $this->source)) ) ) {
       $datei = fopen($this->filename, "w+"); flock($datei, 2);
       fwrite($datei, implode("", $this->content));
       flock($datei, 3); fclose($datei);
       return true;
     } else {
       return false;
     }
   }

   /* public boolean */ function failSafeWrite() {
     for ($i=0; $i<3; $i++) {
       if ($this->write()) {
         return true;
         break;
       } else {
         sleep(0.7);
       }
     }
     return false;
   }

   /* public boolean */ function create() {
     if (!$this->exists() && $this->filename) {
       fclose(fopen($this->filename, "w+"));
       $this->read();
       return true;
     } else {
       return false;
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   /* public boolean */ function is_writeable() {
     return ( $this->exists() && is_writeable($this->filename) );
   }

   /* public integer */ function length() {
     return count($this->content);
   }

   /* public boolean */ function remove(/* String */ $key = "") {
     settype($key, "string");

     if (!$key || $key == "*") {
       $this->content = array();
       return true;

# EXPERIMENTAL FEATURE !!! USE AT OWN RISK !!!

     } else {
       $key = decodeAdress($key);
       $test = false;
       eval ("\$test = isset(\$this->content$key);");
       if ($test) eval ("unset(\$this->content$key);");
       return $test;
     }
     
# END EXPERIMENTAL SECTION

   }

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
