<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

/* public */ class view extends serializeableObject {

  /* private Hashtable */  var $attributes;
  /* private String */     var $baseView;
  /* private String */     var $selected;
  /* private String[][] */ var $filter = array();
  /* public document */    var $document;

  /* constructor */ function view(/* Hashtable */ $ARGS) {
    settype($ARGS, "array");

    $this->attributes = $ARGS;
  }

  /* public void */ function setAttributes(/* Hashtable */ $ARGS) {
    settype($ARGS, "array");

    $this->attributes = $ARGS;
  }
  /* public void */ function addAttributes(/* Hashtable */ $ARGS) {
    settype($ARGS, "array");

    $this->attributes += $ARGS;
  }

  /* public boolean */ function selectView(/* String */ $view_name) {
    settype($view_name, "string");

    if ($this->attributes[$view_name]) {
      $this->selected = $this->attributes[$view_name];
      return true;
    } else {
      echo "<P>WARNING: invalid view name \"$view_name\" supplied for opperation \"selectView\". View is not registered.</P>\n";
      return false;
    }
  }

  /* public void */ function setView(/* String */ $view_name) {
    settype($view_name, "string");

    if (file_exists($view_name)) {
      $this->selected = $view_name;
      return true;
    } else {
      echo "<P>WARNING: invalid filename \"$view_name\" supplied for opperation \"setView\". Error 404: File does not exist.</P>\n";
      return false;
    }
  }
  
  /* public String */ function getView() {
     return $this->selected;
  }

  /* public void */ function unsetView() {
    $this->selected = "";
  }

  /* public boolean */ function selectBaseView(/* String */ $view_name) {
    settype($view_name, "string");

    if ($this->attributes[$view_name]) {
      $this->baseView = $this->attributes[$view_name];
      return true;
    } else {
      echo "<P>WARNING: invalid view name \"$view_name\" supplied for opperation \"selectBaseView\". View is not registered.</P>\n";
      return false;
    }
  }

  /* public void */ function setBaseView(/* String */ $view_name) {
    settype($view_name, "string");

    if (file_exists($view_name)) {
      $this->baseView = $view_name;
      return true;
    } else {
      echo "<P>WARNING: invalid filename \"$view_name\" supplied for opperation \"setBaseView\". Error 404: File does not exist.</P>\n";
      return false;
    }
  }

  /* public void */ function unsetBaseView() {
    $this->baseView = "";
  }

  /* public String */ function getBaseView() {
     return $this->baseView;
  }

  /* public boolean */ function buildPage() {
     if ($this->baseView) {
       $this->document = new document($this->baseView);
       $this->document->read();
       if ($this->selected) $this->document->insertFile($this->selected);
       return true;
     }
     return false;
  }
  
  /* public boolean */ function show() {
    if ($this->document && !$this->document->isEmpty()) {
      $this->applyFilter();
      $this->document->write();
      return true;
    } else {
      return false;
    }
  }
  
  /* public boolean */ function setOptions(/* String */ $key) {
    settype($key, "string");

    if ($this->document && !$this->document->isEmpty()) {
      global $PROGRAM;
      $this->document->options = $PROGRAM->getRegistryKey($key);
      return true;
    } else {
      return false;
    }
  }

  /* public boolean */ function addOptions(/* String */ $key) {
    settype($key, "string");

    if ($this->document && !$this->document->isEmpty()) {
      global $PROGRAM;
      $this->document->options += $PROGRAM->getRegistryKey($key);
      return true;
    } else {
      return false;
    }
  }

  /* public void */ function addFilter(/* String */ $a, $b) {
    $this->filter[count($this->filter)] = array($a,$b);
  }

  /* public void */ function applyFilter() {
    for ($i=0;$i<count($this->filter);$i++) {
      $this->document->replace($this->filter[$i][0],$this->filter[$i][1]);
    }
  }

  /* public void */ function meldung(/* String */ $level, /* String */ $errcode, /* String */ $event) {
    settype($level, "string");
    settype($errcode, "string");
    settype($event, "string");
    global $HTTP_GET_VARS, $HTTP_POST_VARS;

    if (!$this->selectBaseView($level.".html")) die("<P>ERROR: invalid filename \"$level.html\" supplied. Unable to create page.\n");
  	$this->unsetView();
  	$this->buildPage();

      global $PROGRAM;
      $PROGRAM->registry->mount("language_message_file");

    $this->setOptions("TEXT/$errcode");
    foreach ($HTTP_GET_VARS as $a => $b) if (!isset($this->document->options[strtoupper($a)])) $this->document->options[strtoupper($a)] = $b;
    foreach ($HTTP_POST_VARS as $a => $b) if (!isset($this->document->options[strtoupper($a)])) $this->document->options[strtoupper($a)] = $b;
    $this->addOptions("*");
    $this->document->options['ACTION'] = $event;
    $this->show();
    die;
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
