<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

function embeddedTags($txt) {

  settype($txt, "string");

  $txt = preg_replace("/\[b\](.*)(\[\/b\]|$)/Usi",               "<span style=\"font-weight: bold;\">\\1</span>", $txt);
  $txt = preg_replace("/\[i\](.*)(\[\/i\]|$)/Usi",               "<span style=\"font-style: italic;\">\\1</span>", $txt);
  $txt = preg_replace("/\[u\](.*)(\[\/u\]|$)/Usi",               "<span style=\"text-decoration: underline;\">\\1</span>", $txt);
  $txt = preg_replace("/\[emp\](.*)(\[\/emp\]|$)/Usi",           "<span class=\"EMPHASIZE\">\\1</span>", $txt);
  $txt = preg_replace("/\[h\](.*)(\[\/h\]|$)/Usi",               "<p class=\"HIGHLIGHT\">\\1</p>", $txt);
  $txt = preg_replace("/\[c\](.*)(\[\/c\]|$)/Usi",               "<div class=\"KOMMENTAR\">\\1</div>", $txt);
  $txt = preg_replace("/\[hide\](.*)(\[\/hide\]|$)/Usi",         "<div style=\"padding: 5px; border: 1px solid #555555; background-color: #CCCCCC; color: #CCCCCC\" onMouseOver=\"this.style.backgroundColor='#F0F0F0'; this.style.color='#333333'\" onMouseOut=\"this.style.backgroundColor='#CCCCCC'; this.style.color='#CCCCCC'\">\\1</div>", $txt);

  $txt = preg_replace("/\[small\](.*)(\[\/small\]|$)/Usi",       "<span style=\"font-size: x-small\">\\1</span>", $txt);
  $txt = preg_replace("/\[big\](.*)(\[\/big\]|$)/Usi",           "<span style=\"font-size: large\">\\1</span>", $txt);
  $txt = preg_replace("/\[code\](.*)(\[\/code\]|$)/Usi",         "<code style=\"white-space: pre-wrap\">\\1</code>", $txt);
  $txt = preg_replace("/\[mark\](.*)(\[\/mark\]|$)/Usi",         "<span style=\"background-color:#FFFF00\">\\1</span>", $txt);
  $txt = preg_replace("/\[mark=(\S+)\](.*)(\[\/mark\]|$)/Usi",   "<span style=\"background-color:\\1\">\\2</span>", $txt);
  $txt = preg_replace("/\[color\](.*)(\[\/color\]|$)/Usi",       "<span style=\"color:#000000\">\\1</span>", $txt);
  $txt = preg_replace("/\[color=(\S+)\](.*)(\[\/color\]|$)/Usi", "<span style=\"color:\\1\">\\2</span>", $txt);

  $txt = preg_replace("/\[url=http:\/\/(.*)\]/Usi",              "[url=\\1]", $txt);
  $txt = preg_replace("/\[url]http:\/\/(.*)\[\/url\]/Usi",       "[url]\\1[/url]", $txt);
  $txt = preg_replace("/\[mail=mailto:(.*)\]/Usi",               "[mail=\\1]", $txt);
  $txt = preg_replace("/\[mail]mailto:(.*)\[\/mail\]/Usi",       "[mail]\\1[/mail]", $txt);

  $matches = array();
  while (preg_match("/\[img\](.*)\[\/img\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[img\]'.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\[\/img\]/Ui', '<img border=0 src="'.htmlentities(strip_tags(preg_replace("/\[wbr\]/i", "", $matches[1]))).'" style="max-width: 320px; max-height: 240px" onload="javascript:if(this.width>320) { this.width=320; }; if(this.height>240) { this.height=240; };">', $txt);
  }
  $matches = array();
  while (preg_match("/\[mail\](.*)\[\/mail\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[mail\]'.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\[\/mail\]/Ui', '<a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;'.htmlentities(strip_tags(preg_replace("/^mailto:|\[wbr\]/i", "", $matches[1]))).'" target="_blank">'.$matches[1].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[mail=(.*)\](.*)\[\/mail\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[mail='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]'.addcslashes($matches[2], "+()[]{}.?*/\\$^").'\[\/mail\]/Ui', '<a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;'.htmlentities(strip_tags(preg_replace("/^mailto:|\[wbr\]/i", "", $matches[1]))).'" target="_blank">'.$matches[2].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[url=(.*)\](.*)\[\/url\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[url='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]'.addcslashes($matches[2], "+()[]{}.?*/\\$^").'\[\/url\]/Ui', '<a href="http://'.htmlentities(strip_tags(preg_replace("/^http:\/\/|\[wbr\]/i", "", $matches[1]))).'" target="_blank">'.$matches[2].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[url\](.*)\[\/url\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[url\]'.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\[\/url\]/Ui', '<a href="http://'.htmlentities(strip_tags(preg_replace("/^http:\/\/|\[wbr\]/i", "", $matches[1]))).'" target="_blank">'.$matches[1].'</a>', $txt);
  }

  $txt = preg_replace("/\[br\]/i", '<br>', $txt);
  $txt = preg_replace("/\[wbr\]/i", '<span style="font-size: 0px"> </span>', $txt);

  $txt = preg_replace("/\[(b|i|emp|h|code|img|mark|color|url|mail)\]/si", "", $txt);

  return $txt;
}

function addSmilies($txt) {

  settype($txt, "string");
  global $smilies, $DIR;

  // Standard-Smilies
  if (isset($smilies) && is_array($smilies)) {
    if (in_array("smile", $smilies))        { $txt = preg_replace("/:[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'smile.gif">', $txt); }
    if (in_array("teufelchen", $smilies))   { $txt = preg_replace("/>:[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'teufelchen.gif">', $txt); }
    if (in_array("boese", $smilies))        { $txt = preg_replace("/:[\-_o_O]?\(/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'boese.gif">', $txt); }
    if (in_array("keinemeinung", $smilies)) { $txt = preg_replace("/:[\-_o_O]?\|/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'keinemeinung.gif">', $txt); }
    if (in_array("lachen", $smilies))       { $txt = preg_replace("/:[\-_o_O]?D/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'lachen.gif">', $txt); }
    if (in_array("grinsen", $smilies))      { $txt = preg_replace("/;[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'grinsen.gif">', $txt); }
    if (in_array("zunge", $smilies))        { $txt = preg_replace("/:[\-_o_O]?P/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'zunge.gif">', $txt); }
    if (in_array("traurig", $smilies))      { $txt = preg_replace("/:[\'_\*]\(/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'traurig.gif">', $txt); }
  }

  // Emot-Codes                     
  for ($j=0;$j<count($smilies);$j++) {
    while (preg_match("/:".$smilies[$j].":(\s|\[wbr\]|\[br\]|<br \/>)*:".$smilies[$j].":/i", $txt)) {
      $txt = preg_replace("/:".$smilies[$j].":(\s|\[wbr\]|\[br\]|<br \/>)*:".$smilies[$j].":/i", ':'.$smilies[$j].':', $txt);
    }
    $txt = preg_replace("/:".addcslashes($smilies[$j], "+()[]{}.?*/\\$^").":/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].$smilies[$j].'.gif">', $txt);
  }

  return $txt;
}

function loadSmilies($smileyDir) {

  settype($smileyDir, "string");
  if (is_dir($smileyDir)) {
    global $smilies, $DIR;
    $smilies = array();
    $DIR["smilies.dir"] = $smileyDir;
  
    $dir = dir($smileyDir);
    while ($txt = $dir -> read()) {
      if (preg_match("/\.gif$/i", $txt)) {
        $smilies[count($smilies)] = preg_replace("/\..*/", "", $txt);
      }
    }
    $dir -> close();
    sort($smilies);
  }

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
