<?php

/* public */ class plugin_config extends plugin {

  /* public void */ function listener(/* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($ARGS, "array");
    $event = strtolower($event);

    global $PROGRAM;
    $PROGRAM->setRegistryKey("ID",$ARGS['id']);

      switch ($event) {

        case "index":
                 $dir           = $PROGRAM->plugins->getPluginDir();
                 $LANGUAGEFILES = $PROGRAM->registry->files['LANG']->getContent();
                 $SKINFILES     = $PROGRAM->registry->files['SKIN']->getContent();
                 $PLUGINFILES   = $PROGRAM->plugins->getPluginList();
                 $PROFILES      = $PROGRAM->registry->files['CONFIG']->getContent();
                 $PROGRAM->setRegistryKey("LANGUAGEFILES",$LANGUAGEFILES);
                 $PROGRAM->setRegistryKey("SKINFILES",$SKINFILES);
                 $PROGRAM->setRegistryKey("PLUGINFILES",$PLUGINFILES);
                 $PROGRAM->setRegistryKey("PROFILES",$PROFILES);
                 foreach ($PLUGINFILES as $a => $b) {
                   $b = $b['PLUGIN'];
                   if (!empty($b['CONFIG_TEMPLATE']) && isset($b['ACTIVE']) && $b['ACTIVE']) {
                     $PROGRAM->view->addFilter("%LIST OPTIONFILES%", "<%IMPORT ".$dir.$b['CONFIG_TEMPLATE']."%>%LIST OPTIONFILES%");
                   }
                 }
                 $PROGRAM->registry->mount("language_admin_file");
        break;

        case "refresh_pluginlist":
                $PROGRAM->plugins->refreshPluginFile();
                $PROGRAM->meldung("danke", "200", "index");
                return false;
        break;

        case "about":
                 $PROGRAM->registry->mount("language_admin_file");
                 switch ($ARGS['type']) {
                  
                   case "plugin":
                     $file = $PROGRAM->plugins->getPluginFilename($ARGS['target']);
                     if (is_file($file)) {
                       $PROGRAM->registry->merge("*",getConfigFile($file, true));
                       return true;
                     } else {
                       $PROGRAM->meldung("fehler", "404", "index");
                       return false;
                     }
                   break;

                   case "skin":
                     $file = ($PROGRAM->registry->files['SKIN']->filename).$ARGS['target'];
                     if (is_file($file)) {
                       $REF = getConfigFile($file, true);
                       $file = $REF['SETTINGS']['SKIN_INFO_FILE'];
                       if (is_file($file)) {
                         $PROGRAM->registry->merge("*",getConfigFile($file, true));
                         return true;
                       } else {
                         $PROGRAM->meldung("fehler", "404", "index");
                         return false;
                       }
                     } else {
                       $PROGRAM->meldung("fehler", "404", "index");
                       return false;
                     }
                   break;

                   case "language":
                     $file = ($PROGRAM->registry->files['LANG']->filename).$ARGS['target'];
                     if (is_file($file)) {
                       $REF = getConfigFile($file, true);
                       $file = ($PROGRAM->registry->files['LANG']->filename).$REF['TMPL']['LANGUAGE_INFO_FILE'];
                       if (is_file($file)) {
                         $PROGRAM->registry->merge("*",getConfigFile($file, true));
                         return true;
                       } else {
                         $PROGRAM->meldung("fehler", "404", "index");
                         return false;
                       }
                     } else {
                       $PROGRAM->meldung("fehler", "404", "index");
                       return false;
                     }
                   break;

                   default:
                   break;

                 }
        break;

        default:
        break;
      } # end switch

    return true;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
