<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

class dirStream extends inputStream {

   var $content;
   
   var $options = array();
   
   var $filter = "";

   function dirStream($filename) {
     if (!file_exists($filename) || !is_readable($filename) || !is_dir($filename)) {
       $this->exists = false;
     } else {
       $this->attributes['MTIME'] = date("d.m.Y",filemtime($filename));
       $this->attributes['ATIME'] = date("d.m.Y H:i:s",fileatime($filename));
       $this->attributes['CTIME'] = date("d.m.Y",filectime($filename));
       clearstatcache();
       $this->exists = true;
     }
     global $REMOTE_ADDR; if (isset($REMOTE_ADDR)) { $this->attributes['REMOTE_ADDR'] = $REMOTE_ADDR; }
     $this->filename = $filename;
   }

   function read() {
     if (!is_readable($this->filename)) {
       $this->exists  = false;
       return false;
     } else {
       $this->content = dirlist($this->filename, $this->filter);
       sort($this->content);
       $this->options = $this->attributes;
       $this->exists  = true;
       return true;
     }
   }

   function get() {
     if (!$this->isEmpty()) {
       return $this->content;
     } else {
       return array();
     }
   }

   /* public boolean */ function create($mode) {
     if (gettype($mode) != "integer" || strlen($mode) != 3 || $this->exists() || !isset($this->filename)) return false;
     else return mkdir($this->filename,"0$mode");
   }

   function toString() {
     if (!$this->exists()) {
       return "Directory ".$this->filename." does not exist\n";
     } elseif ($this->isEmpty()) {
       return "Directory ".$this->filename." is not loaded\n";
     } else {
       return implode("\n", $this->get());
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   function isEmpty() {
     return ($this->content=="");
   }

   function close() {
     foreach ($this as $key=>$element) {
       unset($this->$key);
     }
   }

   function length() {
     return count($this->content);
   }
   
   function dirlist($filter) {
      $this->filter = $filter;
      $this->read();
      return $this->content;
   }
   
   function getContent() {
      if ($this->isEmpty()) { $this->read(); }
      $REF = array();
      for ($i=0; $i<count($this->content); $i++) {
        $REF[$i]['VALUE'] = $this->content[$i];
        $REF[$i]['NAME']  = preg_replace("/(.*)\..*/", "$1", $this->content[$i]);
      }
      return $REF;
   }

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
