<?php

/* public */ class userSessionTempFile extends configfile {

  /* private String */ var $recentKey = "";

  /* overwrite public String[] */ function init() {

    if ($this->isEmpty()) { $this->read(); }
    if (!$this->exists()) { return false;  }

    $this->value = getConfigFile($this->source,false);
    $this->cleanUp();
    return $this->value;

  }

  /* public String */ function getRecentKey() {
    return $this->recentKey;
  }

  /* public boolean */ function insert(/* mixed */ $REF, /* String */ $username) {
     settype($username, "string");

     if (is_scalar($REF) && isset($username))
     {
       settype($REF, "string");
       $this->recentKey = md5($REF);
       $this->value = mergeArrays($this->value, array ($this->recentKey => array( "UTC" => time(), "MAIL" => $REF, "USERNAME" => $username ) ) );
     }
     else
     {
       settype($REF, "array");
       $this->value = mergeArrays($this->value,$REF);
     }

     $this->content = $this->makeConfig();
     return true;

  }

  /* public boolean */ function keyExists(/* String */ $key) {

    settype($key, "string");

    if (!$this->value) $this->init();
    return isset($this->value[$key]);

  }

   # <--- abgelaufene Sessions entfernen
   /* private void */ function cleanUp() {

       $is_changed = false;

       $time = time();
       foreach ($this->value as $key => $element)
       {
         // Zeitlimit = 24h = 86400sek
         if ($element['UTC']+86400 < $time) {
           unset($this->value[$key]);
           $is_changed = true;
         }
       }

   } # abgelaufene Sessions entfernen --->

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
